#!/usr/bin/perl -w
use strict ;

if (@ARGV != 4){
    print "Usgae: perl $0 matrixfile bcrawfile bcnewfile outfile\n" ;
    exit(1) ;
}

my ($mtfile, $bcrawfile, $bcnewfile, $outfile) = @ARGV ;

if ($bcrawfile =~ m/\.gz$/){
    open (IN, "gunzip -c $bcrawfile |") || die "$bcrawfile, $!\n" ;
}
else{
    open (IN, $bcrawfile) || die "$bcrawfile, $!\n" ;
}
my %hrawindex = ();
my $index = 0 ;
while(<IN>){
    chomp ;
    my $bc = (split)[0] ;
    $index++ ;
    $hrawindex{$index} = $bc ;
}
close(IN);

open (IN, $bcnewfile) || die "$bcnewfile, $!\n" ;
my %hnewindex = ();
$index = 0 ;
while(<IN>){
    chomp ;
    my $bc = (split)[0] ;
    $index++ ;
    $hnewindex{$bc} = $index ;
}
close(IN);
my $bcnum = $index ;

my @matrix = ();
if ($mtfile =~ m/\.gz$/){
    open (IN, "gunzip -c $mtfile |") || die "$mtfile, $!\n" ;
}
else{
    open (IN, $mtfile) || die "$mtfile, $!\n" ;
}
my $h1 = <IN> ;
my $h2 = <IN> ;
my $h3 = <IN> ;
my ($genenum) = (split /\s+/, $h3)[0] ;
while(<IN>){
    chomp ;
    my ($gene, $bcindex, $umi) = split ;
    my $bc = $hrawindex{$bcindex} ;
    if (defined $hnewindex{$bc}){
        my $line = "$gene\t".$hnewindex{$bc}."\t$umi\n" ;
        push @matrix, $line ;
    }
}
close(IN);

open (OUT, ">$outfile") || die "$outfile, $!\n" ;
my $uminum = scalar(@matrix) ;
print OUT "$h1$h2$genenum\t$bcnum\t$uminum\n" ;
print OUT @matrix ;
close(OUT);
