#!/usr/bin/perl -w
use strict ;

if (@ARGV != 2){
    print "Usage: perl $0 reads_info.tsv bc_umi_read.tsv\n" ;
    exit(1);
}

my ($infile, $outfile) = @ARGV ;

open (IN, $infile) || die "$infile, $!\n" ;
my $head = <IN> ;
chomp($head) ;
my @arr = split /\s+/, $head ;
my %hcol = ();
for (my $i=0; $i<@arr; $i++){
    $hcol{$arr[$i]} = $i ;
}

my %hbc_umi = ();
while(<IN>){
    chomp ;
    my @arr = split /\t/ ;
    my $umi_cor = $arr[$hcol{umi_corr}] ;
    next if ($umi_cor eq 'N') ;
    #next if (length($umi_cor) != 12);
    my $bc = $arr[$hcol{cell}] ;
    next if ($bc !~ m/bc1\_\d+\-bc2\_\d+\-bc3\_\d+/);
    my $gene = $arr[$hcol{gene}] ;
    next if ($gene eq 'NA') ;
    $hbc_umi{$bc}{$gene}{$umi_cor}++ ;
}
close(IN);

open (OUT, ">$outfile") || die "$outfile, $!\n" ;
my $one_count = 0 ;
my $sum = 0 ;
for my $bc (keys %hbc_umi){
    for my $gene (keys %{$hbc_umi{$bc}}){
        for my $umi (keys %{$hbc_umi{$bc}{$gene}}){
            my $readnum = $hbc_umi{$bc}{$gene}{$umi} ;
            print OUT "$bc\t$gene\t$umi\t$readnum\n" ;
            if ($readnum == 1){
                $one_count++ ;
            }
            $sum++ ;
        }
    }
}
close(OUT);

my $rate = 1 - $one_count/$sum ;
open (OUT, ">$outfile.stat") || die "$outfile.stat, $!\n" ;
print OUT "Sequencing_saturation\t$rate\n" ;
close(OUT);

