#!/usr/bin/perl -w
use strict ;

if (@ARGV != 2){
    print "Usage: perl $0 ingtffile outfile\n" ;
    exit(1);
}

my ($infile, $outfile) = @ARGV ;

open (IN, $infile) || die "$infile, $!\n" ;
my @genes = ();
my %hinfos = ();
my %hgene = ();
my %hgene_name = ();
while(<IN>){
    chomp ;
    next if (m/^\#|^\s*$/);
    my ($chr, $soft, $type, $start, $end, undef, $ori, undef, @infos) = split ;
    my $gene_id = "" ;
    for (my $i=0; $i<@infos; $i+=2){
        if ($infos[$i] eq 'gene_id'){
            $gene_id = $infos[$i+1] ;
            push @{$hinfos{$infos[$i+1]}}, $_ ;
            if (!defined $hgene{$infos[$i+1]}){
                push @genes, $infos[$i+1] ;
                $hgene{$infos[$i+1]} = [$chr, $soft, $start, $end, $ori] ;
            }
            else{
                if ($hgene{$infos[$i+1]}[2] > $start){
                    $hgene{$infos[$i+1]}[2] = $start ;
                }
                if ($hgene{$infos[$i+1]}[3] < $end){
                    $hgene{$infos[$i+1]}[3] = $end ;
                }
            }
        }
        elsif ($infos[$i] eq 'gene_name'){
            $hgene_name{$gene_id} = $infos[$i+1] ;
        }
    }
}
close(IN);
open (OUT, ">$outfile") || die "$outfile, $!\n" ;
for my $gene (@genes){
    my ($chr, $soft, $start, $end, $ori) = @{$hgene{$gene}} ;
    print OUT "$chr\t$soft\tgene\t$start\t$end\t.\t$ori\t.\tgene_id $gene" ;
    if (defined $hgene_name{$gene}){
        print OUT " gene_name ", $hgene_name{$gene} ;
    }
    print OUT "\n" ;
    for my $str (@{$hinfos{$gene}}){
        print OUT "$str\n" ;
    }
}
close(OUT);

