#!/usr/bin/perl -w
use strict ;

if (@ARGV != 2){
    print "Usage: perl $0 infile outfile\n" ;
    exit(1);
}

my ($infile, $outfile) = @ARGV ;

open (IN, $infile) || die "$infile, $!\n" ;
my %hbc = ();
while(<IN>){
    chomp ;
    next if (m/^\#|^\s*$/);
    my ($id, $bc, $gene, $umi, $perc_start, $perc_end) = split ;
    next if ($perc_end == $perc_start) ;
    if (defined $hbc{$bc}{$umi}){
        if ($hbc{$bc}{$umi}[1] - $hbc{$bc}{$umi}[0] < $perc_end - $perc_start){
            $hbc{$bc}{$umi}[0] = $perc_start ;
            $hbc{$bc}{$umi}[1] = $perc_end ;
        }
    }
    else{
        $hbc{$bc}{$umi} = [$perc_start, $perc_end] ;
    }
}
close(IN);

my @arr = ();
for (my $i=0; $i<=100; $i++){
    $arr[$i] = 0 ;
}

for my $bc (keys %hbc){
    for my $umi (keys %{$hbc{$bc}}){
        my ($start, $end) = @{$hbc{$bc}{$umi}} ;
        for (my $i=$start; $i<=$end; $i++){
            $arr[$i]++ ;
        }
    }
}
open (OUT, ">$outfile") || die "$outfile, $!\n" ;
print OUT "#Percentile\tNumber\n" ;
for (my $i=0; $i<=100; $i++){
    print OUT "$i\t$arr[$i]\n" ;
}
close(OUT);

